## mingw-w64-blender-4.4.3-3.src.tar.zst

=== build_files/build_environment/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

##################################################################################################
#
# This is a build system used by platform maintainers to build library dependencies.
# For users building Blender, we recommend using the pre-compiled libraries from `lib/`
# on all platforms.
#
# This CMake project is usually built through wrappers:
# * Windows: `build_files/build_environment/windows/build_deps.cmd`.
# * macOS and Linux: `make deps` from the blender directory.
#
##################################################################################################

cmake_minimum_required(VERSION 3.5)
project("BlenderDependencies")
if(POLICY CMP0135)
  cmake_policy(SET CMP0135 NEW) # CMake 3.24+ Set the date/time for extracted files to time of extraction
endif()
include(ExternalProject)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/../cmake/Modules")

include(cmake/check_software.cmake)
include(cmake/options.cmake)
# `versions.cmake` needs to be included after `options.cmake`
# due to the `BLENDER_PLATFORM_ARM` variable being needed.
include(cmake/versions.cmake)
include(cmake/download.cmake)
include(cmake/macros.cmake)
# `setup_msys2.cmake` to install `perl`,
# which HIP needs to function for the compiler detection to work properly,
# hence needs to be included before `check_compilers.cmake`.
if(ENABLE_MSYS2)
  include(cmake/setup_msys2.cmake)
else()
  set(mingw_LIBDIR ${LIBDIR})
endif()
include(cmake/check_compilers.cmake)
include(cmake/harvest.cmake)

include(cmake/ssl.cmake)
include(cmake/zlib.cmake)
include(cmake/zstd.cmake)
include(cmake/openal.cmake)
include(cmake/png.cmake)
include(cmake/jpeg.cmake)
include(cmake/blosc.cmake)
include(cmake/pthreads.cmake)
include(cmake/deflate.cmake)
include(cmake/imath.cmake)
include(cmake/openexr.cmake)
include(cmake/brotli.cmake)
include(cmake/freetype.cmake)
include(cmake/epoxy.cmake)
include(cmake/alembic.cmake)
include(cmake/opensubdiv.cmake)
include(cmake/sdl.cmake)
include(cmake/opencollada.cmake)
if(APPLE)
  include(cmake/openmp.cmake)
endif()
if(UNIX)
  include(cmake/nasm.cmake)
endif()
include(cmake/tiff.cmake)
if(WIN32)
  include(cmake/flexbison.cmake)
elseif(UNIX AND NOT APPLE)
  include(cmake/flex.cmake)
endif()
include(cmake/tbb.cmake)
include(cmake/python.cmake)
include(cmake/llvm.cmake)
include(cmake/osl.cmake)
include(cmake/numpy.cmake)
include(cmake/python_site_packages.cmake)
include(cmake/package_python.cmake)
include(cmake/openimageio.cmake)
include(cmake/usd.cmake)
include(cmake/materialx.cmake)
include(cmake/openvdb.cmake)
include(cmake/potrace.cmake)
include(cmake/haru.cmake)
include(cmake/pugixml.cmake)
include(cmake/fribidi.cmake)
include(cmake/harfbuzz.cmake)
if(NOT APPLE)
  include(cmake/xr_openxr.cmake)
  if(NOT BLENDER_PLATFORM_ARM)
    # HIP-RT requires special SDK which is not widely available yet.
    if(NOT WIN32)
      include(cmake/hiprt.cmake)
    endif()
    include(cmake/dpcpp.cmake)
    include(cmake/dpcpp_deps.cmake)
    if(NOT WIN32)
      include(cmake/igc.cmake)
      include(cmake/gmmlib.cmake)
      include(cmake/ocloc.cmake)
    endif()
  endif()
endif()
include(cmake/ispc.cmake)
if(BLENDER_PLATFORM_WINDOWS_ARM)
  include(cmake/openpgl_windows_arm.cmake)
else()
  include(cmake/openpgl.cmake)
endif()
# EMBREE needs to be included after `dpcpp` as it uses it for compiling with GPU support
if(BLENDER_PLATFORM_WINDOWS_ARM)
  # WoA needs EMBREE to be built with the VS Generator + LLVM,
  # put it in its own file to avoid clutter.
  include(cmake/embree_windows_arm.cmake)
else()
  include(cmake/embree.cmake)
endif()
include(cmake/fmt.cmake)
include(cmake/robinmap.cmake)
include(cmake/xml2.cmake)
# OpenColorIO and dependencies.
include(cmake/expat.cmake)
include(cmake/pystring.cmake)
include(cmake/yamlcpp.cmake)
include(cmake/minizipng.cmake)
include(cmake/opencolorio.cmake)

if(BLENDER_PLATFORM_ARM)
  include(cmake/sse2neon.cmake)
endif()

include(cmake/webp.cmake)
if(NOT APPLE)
  include(cmake/level-zero.cmake)
endif()

if(NOT WIN32 OR ENABLE_MSYS2)
  include(cmake/gmp.cmake)
  include(cmake/openjpeg.cmake)
  if(NOT WIN32 OR BUILD_MODE STREQUAL Release)
    include(cmake/openimagedenoise.cmake)
    include(cmake/lame.cmake)
    include(cmake/ogg.cmake)
    include(cmake/vorbis.cmake)
    include(cmake/theora.cmake)
    include(cmake/opus.cmake)
    include(cmake/vpx.cmake)
    include(cmake/x264.cmake)
    include(cmake/x265.cmake)
    include(cmake/aom.cmake)
    include(cmake/ffmpeg.cmake)
    include(cmake/fftw.cmake)
    include(cmake/flac.cmake)
    include(cmake/sndfile.cmake)
    if(UNIX)
      if(NOT APPLE)
        include(cmake/spnav.cmake)
        include(cmake/jemalloc.cmake)
      endif()
    endif()
  endif()
endif()

if(UNIX)
  include(cmake/bzip2.cmake)
  include(cmake/ffi.cmake)
  include(cmake/lzma.cmake)
  include(cmake/sqlite.cmake)
endif()

if(UNIX AND NOT APPLE)
  include(cmake/libglu.cmake)
  include(cmake/mesa.cmake)
  include(cmake/wayland_protocols.cmake)
  # Can be removed when the build-bot upgrades to v1.20.x or newer.
  include(cmake/wayland.cmake)
  include(cmake/wayland_libdecor.cmake)
  include(cmake/wayland_weston.cmake)
endif()
include(cmake/shaderc_deps.cmake)
include(cmake/shaderc.cmake)
include(cmake/vulkan.cmake)
include(cmake/pybind11.cmake)
include(cmake/nanobind.cmake)
# Keep these last
include(cmake/deps_html.cmake)
include(cmake/cve_check.cmake)

=== intern/dualcon/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2002-2022 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  .
  intern
  ../guardedalloc
)

set(INC_SYS
  ${EIGEN3_INCLUDE_DIRS}
)

set(SRC
  intern/manifold_table.cpp
  intern/marching_cubes_table.cpp
  intern/octree.cpp
  intern/Projections.cpp

  intern/cubes.h
  intern/GeoCommon.h
  intern/manifold_table.h
  intern/marching_cubes_table.h
  intern/MemoryAllocator.h
  intern/ModelReader.h
  intern/octree.h
  intern/Projections.h
  intern/Queue.h

  intern/dualcon_c_api.cpp
  dualcon.h
)

set(LIB
)

blender_add_lib(bf_intern_dualcon "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")

=== source/blender/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(SRC_DNA_INC
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_ID.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_ID_enums.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_action_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_anim_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_armature_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_asset_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_boid_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_brush_enums.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_brush_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_cachefile_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_camera_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_cloth_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_collection_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_color_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_constraint_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_curve_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_curveprofile_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_curves_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_customdata_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_defs.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_documentation.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_dynamicpaint_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_effect_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_fileglobal_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_fluid_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_freestyle_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_genfile.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_gpencil_legacy_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_gpencil_modifier_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_gpu_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_grease_pencil_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_image_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_ipo_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_key_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_lattice_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_layer_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_light_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_lightprobe_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_lineart_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_linestyle_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_listBase.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_mask_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_material_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_mesh_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_meshdata_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_meta_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_modifier_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_movieclip_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_nla_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_node_tree_interface_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_node_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_object_enums.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_object_fluidsim_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_object_force_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_object_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_outliner_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_packedFile_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_particle_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_pointcache_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_pointcloud_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_rigidbody_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_scene_enums.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_scene_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_screen_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_sdna_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_sequence_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_session_uid_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_shader_fx_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_sound_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_space_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_speaker_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_text_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_texture_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_tracking_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_userdef_enums.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_userdef_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_uuid_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_vec_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_vfont_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_view2d_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_view3d_enums.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_view3d_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_viewer_path_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_volume_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_windowmanager_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_workspace_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_world_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_xr_types.h
)

set(SRC_DNA_DEFAULTS_INC
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_action_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_armature_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_asset_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_brush_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_cachefile_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_camera_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_collection_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_curve_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_curves_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_fluid_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_gpencil_modifier_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_grease_pencil_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_image_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_lattice_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_light_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_lightprobe_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_linestyle_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_material_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_mesh_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_meta_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_modifier_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_movieclip_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_object_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_particle_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_pointcloud_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_scene_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_space_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_speaker_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_texture_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_userdef_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_vec_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_view3d_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_volume_defaults.h
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_world_defaults.h
)

# Utility & other headers.
set(SRC_DNA_OTHER_INC
  ${CMAKE_CURRENT_SOURCE_DIR}/makesdna/DNA_array_utils.hh
)

add_subdirectory(datatoc)
add_subdirectory(gpu/glsl_preprocess)
add_subdirectory(editors)
add_subdirectory(windowmanager)
add_subdirectory(animrig)
add_subdirectory(asset_system)
add_subdirectory(blenkernel)
add_subdirectory(blenlib)
add_subdirectory(bmesh)
add_subdirectory(draw)
add_subdirectory(draw/intern/shaders)
add_subdirectory(draw/engines/eevee_next/shaders)
add_subdirectory(draw/engines/gpencil/shaders)
add_subdirectory(draw/engines/workbench/shaders)
add_subdirectory(render)
add_subdirectory(blenfont)
add_subdirectory(blentranslation)
add_subdirectory(blenloader)
add_subdirectory(depsgraph)
add_subdirectory(ikplugin)
add_subdirectory(simulation)
add_subdirectory(geometry)
add_subdirectory(gpu)
add_subdirectory(gpu/shaders)
add_subdirectory(imbuf)
add_subdirectory(imbuf/intern/oiio)
add_subdirectory(nodes)
add_subdirectory(modifiers)
add_subdirectory(sequencer)
add_subdirectory(shader_fx)
add_subdirectory(io)
add_subdirectory(functions)
add_subdirectory(makesdna)
add_subdirectory(makesrna)
add_subdirectory(compositor)

if(WITH_BLENDER_THUMBNAILER)
  add_subdirectory(blendthumb)
endif()


if(WITH_IMAGE_OPENEXR)
  add_subdirectory(imbuf/intern/openexr)
endif()

if(WITH_IMAGE_CINEON)
  add_subdirectory(imbuf/intern/cineon)
endif()

if(WITH_PYTHON)
  add_subdirectory(python)
endif()

if(WITH_FREESTYLE)
  add_subdirectory(freestyle)
endif()

if(WITH_CPU_CHECK)
  add_subdirectory(cpucheck)
endif()

=== source/creator/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  ../blender/editors/include
  ../blender/io/usd
  ../blender/makesrna
)

set(LIB
  PRIVATE bf::blenkernel
  PRIVATE bf::blenlib
  PRIVATE bf::bmesh
  PRIVATE bf::depsgraph
  PRIVATE bf::dna
  PRIVATE bf::gpu
  PRIVATE bf::imbuf
  PRIVATE bf::imbuf::movie
  PRIVATE bf::intern::clog
  PRIVATE bf::intern::guardedalloc
  PRIVATE bf::render
  PRIVATE bf::windowmanager
)

if(HAVE_FEENABLEEXCEPT)
  add_definitions(-DHAVE_FEENABLEEXCEPT)
endif()

if(WITH_STRSIZE_DEBUG)
  add_definitions(-DWITH_STRSIZE_DEBUG)
endif()

if(WITH_TBB)
  # Force TBB libraries to be in front of MKL (part of `OpenImageDenoise`), so
  # that it is initialized before MKL and static library initialization order issues are avoided.
  #
  # This isn't fully robust but seems to work.
  list(INSERT LIB 0 ${TBB_LIBRARIES})
  list(INSERT LIB 0 bf_blenkernel)
endif()

if(WITH_OPENMP AND WITH_OPENMP_STATIC)
  list(APPEND LIB
    ${OpenMP_LIBRARIES}
  )
endif()

if(WIN32)
  list(APPEND INC ../../intern/utfconv)
endif()

if(WITH_LIBMV)
  list(APPEND INC ../../intern/libmv)
  add_definitions(-DWITH_LIBMV)
endif()

if(WITH_CYCLES)
  add_definitions(-DWITH_CYCLES)
  if(WITH_CYCLES_LOGGING)
    list(APPEND INC ../../intern/cycles/blender)
    add_definitions(-DWITH_CYCLES_LOGGING)
  endif()
endif()

if(WITH_OPENGL_BACKEND)
  add_definitions(-DWITH_OPENGL_BACKEND)
endif()

if(WITH_VULKAN_BACKEND)
  add_definitions(-DWITH_VULKAN_BACKEND)
endif()

if(WITH_RENDERDOC)
  add_definitions(-DWITH_RENDERDOC)
endif()

if(WITH_CODEC_FFMPEG)
  add_definitions(-DWITH_FFMPEG)
endif()

if(WITH_TBB)
  list(APPEND INC ${TBB_INCLUDE_DIRS})
  if(WIN32)
    # For `pragma` that links `tbbmalloc_proxy.lib`.
    link_directories(${LIBDIR}/tbb/lib)
  endif()
endif()

if(WIN32)
  # Windows.h will define min/max macros that will collide with the STL versions.
  add_definitions(-DNOMINMAX)
endif()

if(WITH_USD)
  # USD links libMaterialX, when using pre-compiled libraries
  # ensures `usd_ms` can find `MaterialXRender` and friends.
  #
  # NOTE: This is _only_ needed when linking blender before the install target runs.
  # Once MATERIALX libraries have been copied into `TARGETDIR_LIB` then Blender will link.
  # Don't rely on this though as failing on a fresh build is no good and the library
  # files could get outdated too.
  if(DEFINED LIBDIR)
    link_directories(${LIBDIR}/materialx/lib)
  endif()
endif()

if(WITH_PYTHON)
  list(APPEND INC ../blender/python)
  add_definitions(-DWITH_PYTHON)

  if(WITH_PYTHON_SECURITY)
    add_definitions(-DWITH_PYTHON_SECURITY)
  endif()
endif()

if(WITH_HEADLESS)
  add_definitions(-DWITH_HEADLESS)
endif()

if(WITH_SDL)
  add_definitions(-DWITH_SDL)
endif()

if(WITH_BINRELOC)
  list(APPEND INC ${BINRELOC_INCLUDE_DIRS})
  add_definitions(-DWITH_BINRELOC)
endif()

if(WITH_FREESTYLE)
  list(APPEND INC ../blender/freestyle)
  add_definitions(-DWITH_FREESTYLE)
endif()

if(WITH_XR_OPENXR)
  add_definitions(-DWITH_XR_OPENXR)
endif()

if(WITH_GMP)
  list(APPEND INC ${GMP_INCLUDE_DIRS})
  add_definitions(-DWITH_GMP)
endif()

if(WITH_OPENCOLORIO)
  add_definitions(-DWITH_OCIO)
endif()

# Setup the EXE sources and `buildinfo`.
set(SRC
  creator.cc
  creator_args.cc
  creator_signals.cc

  creator_intern.h
)

if(CMAKE_GENERATOR MATCHES "^Visual Studio.+")
  # This helps visual studio find the debugger visualizers
  list(APPEND SRC ${CMAKE_SOURCE_DIR}/tools/utils_ide/natvis/Blender.natvis)
endif()

# MSVC 2010 gives linking errors with the manifest.
if(WIN32 AND NOT UNIX)
  add_definitions(
    -DBLEN_VER_RC_STR="${BLENDER_VERSION}"
    -DBLEN_VER_RC_1=${BLENDER_VERSION_MAJOR}
    -DBLEN_VER_RC_2=${BLENDER_VERSION_MINOR}
    -DBLEN_VER_RC_3=${BLENDER_VERSION_PATCH}
    -DBLEN_VER_RC_4=0
  )

  list(APPEND SRC
    ${CMAKE_SOURCE_DIR}/release/windows/icons/winblender.rc
  )

  if(NOT WITH_WINDOWS_EXTERNAL_MANIFEST)
    list(APPEND SRC
      ${CMAKE_BINARY_DIR}/blender.exe.manifest
    )
  endif()
endif()

if(WITH_BUILDINFO)
  add_definitions(-DWITH_BUILDINFO)
  # --------------------------------------------------------------------------
  # These defines could all be moved into the header below

  # Write strings into a separate header since we can escape C-strings
  # in a way that's not practical when passing defines.
  set(BUILD_PLATFORM "${CMAKE_SYSTEM_NAME}")
  set(BUILD_TYPE "${CMAKE_BUILD_TYPE}")
  set(BUILD_CFLAGS "${CMAKE_C_FLAGS}")
  set(BUILD_CXXFLAGS "${CMAKE_CXX_FLAGS}")
  set(BUILD_LINKFLAGS "${PLATFORM_LINKFLAGS}")
  set(BUILD_SYSTEM "CMake")

  if(WITH_COMPILER_SHORT_FILE_MACRO)
    # It's not necessary to include path information
    # about the system building Blender in the executable.
    string(REPLACE "${PLATFORM_CFLAGS_FMACRO_PREFIX_MAP}" " " BUILD_CFLAGS "${BUILD_CFLAGS}")
    string(REPLACE "${PLATFORM_CFLAGS_FMACRO_PREFIX_MAP}" " " BUILD_CXXFLAGS "${BUILD_CXXFLAGS}")
  endif()

  # Use `configure_file` instead of definitions since properly
  # escaping the multiple command line arguments which themselves
  # contain strings and spaces becomes overly error-prone & complicated.
  configure_file(
    "${CMAKE_SOURCE_DIR}/build_files/cmake/buildinfo_static.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/buildinfo_static.h"
    ESCAPE_QUOTES
    @ONLY
  )

  unset(BUILD_PLATFORM)
  unset(BUILD_TYPE)
  unset(BUILD_CFLAGS)
  unset(BUILD_CXXFLAGS)
  unset(BUILD_LINKFLAGS)
  unset(BUILD_SYSTEM)

  # --------------------------------------------------------------------------
  # Write header for values that change each build
  #
  # NOTE: generated file is in build directory `source/creator`
  # except when used as an include path.

  add_definitions(-DWITH_BUILDINFO_HEADER)

  # Include the output directory, where the `buildinfo.h` file is generated.
  include_directories(${CMAKE_CURRENT_BINARY_DIR})


  # XXX: `${buildinfo_h_fake}` is used here,
  # because we rely on that file being detected as missing
  # every build so that the real header `buildinfo.h` is updated.
  #
  # Keep this until we find a better way to resolve!

  set(buildinfo_h_real "${CMAKE_CURRENT_BINARY_DIR}/buildinfo.h")
  set(buildinfo_h_fake "${CMAKE_CURRENT_BINARY_DIR}/buildinfo.h_fake")

  if(EXISTS ${buildinfo_h_fake})
    message(
      FATAL_ERROR
      "File \"${buildinfo_h_fake}\" found, this should never be created, remove!"
    )
  endif()

  # From the CMAKE documentation "If the output of the custom command is not actually created as a
  # file on disk it should be marked with the SYMBOLIC source file property."
  #
  # Not doing this leads to build warnings for the not generated file on
  # MS-Windows when using `msbuild`.
  set_source_files_properties(${buildinfo_h_fake} PROPERTIES SYMBOLIC TRUE)

  # a custom target that is always built
  add_custom_target(
    buildinfo ALL
    DEPENDS ${buildinfo_h_fake}
  )

  # Creates `buildinfo.h` using CMAKE script.
  add_custom_command(
    OUTPUT
      ${buildinfo_h_fake}  # ensure we always run
      ${buildinfo_h_real}
    COMMAND
      ${CMAKE_COMMAND}
      -DSOURCE_DIR=${CMAKE_SOURCE_DIR}
      # Overrides only used when non-empty strings.
      -DBUILD_DATE=${BUILDINFO_OVERRIDE_DATE}
      -DBUILD_TIME=${BUILDINFO_OVERRIDE_TIME}
      -P ${CMAKE_SOURCE_DIR}/build_files/cmake/buildinfo.cmake
  )

  # `buildinfo.h` is a generated file.
  set_source_files_properties(
    ${buildinfo_h_real}
    PROPERTIES GENERATED TRUE
    HEADER_FILE_ONLY TRUE)

  unset(buildinfo_h_real)
  unset(buildinfo_h_fake)

  # Add dependencies below, after adding Blender
  # -------------- done with header values.

  list(APPEND SRC
    buildinfo.c
  )

  # make an object library so can load with it in tests
  add_library(buildinfoobj OBJECT buildinfo.c)
  add_dependencies(buildinfoobj buildinfo)
endif()

add_cc_flags_custom_test(blender)

# message(STATUS "Configuring blender")
if(WITH_PYTHON_MODULE)
  add_definitions(-DWITH_PYTHON_MODULE)

  # Creates `./bpy/__init__.so` which can be imported as a Python module.
  #
  # Note that 'SHARED' works on Linux and Windows, but not MACOS which _must_ be 'MODULE'.
  add_library(blender MODULE ${SRC})


  get_property(GENERATOR_IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  if(GENERATOR_IS_MULTI_CONFIG)
    set(BPY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/$<CONFIG>/bpy)
  else()
    set(BPY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/bpy)
  endif()

  set_target_properties(
    blender
    PROPERTIES
      PREFIX ""
      OUTPUT_NAME __init__
      LIBRARY_OUTPUT_DIRECTORY ${BPY_OUTPUT_DIRECTORY}
      RUNTIME_OUTPUT_DIRECTORY ${BPY_OUTPUT_DIRECTORY}
  )
  unset(BPY_OUTPUT_DIRECTORY)

  if(APPLE)
    set_target_properties(blender PROPERTIES MACOSX_BUNDLE TRUE)
    if(WITH_BLENDER_THUMBNAILER)
      set_target_properties(blender-thumbnailer PROPERTIES MACOSX_BUNDLE TRUE)
    endif()
  endif()

  if(WIN32)
    # Python modules use this.
    set_target_properties(
      blender
      PROPERTIES
      SUFFIX ".pyd"
    )
  endif()

else()
  add_executable(blender ${EXETYPE} ${SRC})
  if(WITH_CPU_CHECK)
    # blender_cpu_check *NEEDS* to be linked first, there can be no exceptions
    # to this, this is to ensure this will be the first code to run once the
    # blender binary has been loaded by the OS.
    target_link_libraries(blender PRIVATE blender_cpu_check)
  endif()
  if(WIN32)
    add_executable(blender-launcher WIN32
      blender_launcher_win32.c
      ${CMAKE_SOURCE_DIR}/release/windows/icons/winblender.rc
    )
    if(NOT WITH_WINDOWS_EXTERNAL_MANIFEST)
      target_sources(blender-launcher PRIVATE
        ${CMAKE_BINARY_DIR}/blender.exe.manifest
      )
    endif()
    target_compile_definitions(blender-launcher PRIVATE -D_UNICODE -DUNICODE)
    target_link_libraries(blender-launcher Pathcch.lib)
  endif()
endif()

if(WITH_BUILDINFO)
  # Explicitly say that the executable depends on the `buildinfo`.
  add_dependencies(blender buildinfo)
endif()


set(BLENDER_TEXT_FILES
  # Generate this file:
  # `${CMAKE_SOURCE_DIR}/release/text/readme.html`
)

if(WITH_INSTALL_COPYRIGHT)
  list(APPEND BLENDER_TEXT_FILES
    ${CMAKE_SOURCE_DIR}/release/text/copyright.txt
  )
endif()

# -----------------------------------------------------------------------------
# Platform specific target destinations
#
# Setup version directory, libraries, `bpy` & text files.

if(UNIX AND NOT APPLE)
  if(WITH_PYTHON_MODULE)
    if(WITH_INSTALL_PORTABLE)
      set(TARGETDIR_BPY "bpy")
      set(TARGETDIR_VER "bpy/${BLENDER_VERSION}")
      set(TARGETDIR_LIB "bpy/lib")
    else()
      set(TARGETDIR_BPY ${PYTHON_SITE_PACKAGES}/bpy)
      set(TARGETDIR_VER ${PYTHON_SITE_PACKAGES}/bpy/${BLENDER_VERSION})
      set(TARGETDIR_LIB ${PYTHON_SITE_PACKAGES}/bpy/lib)
    endif()
  else()
    if(WITH_INSTALL_PORTABLE)
      set(TARGETDIR_VER "${BLENDER_VERSION}")
      set(TARGETDIR_TEXT ".")
      set(TARGETDIR_LIB "lib")
    else()
      set(TARGETDIR_VER "share/blender/${BLENDER_VERSION}")
      set(TARGETDIR_TEXT "share/doc/blender")
    endif()
  endif()
  set(TARGETDIR_SITE_PACKAGES "${TARGETDIR_VER}/python/lib/python${PYTHON_VERSION}/site-packages")
elseif(WIN32)
  if(WITH_PYTHON_MODULE)
    set(TARGETDIR_BPY ${CMAKE_INSTALL_PREFIX_WITH_CONFIG}/bpy)
    set(TARGETDIR_VER ${CMAKE_INSTALL_PREFIX_WITH_CONFIG}/bpy/${BLENDER_VERSION})
    # Important the DLL's are next to `__init__.pyd` otherwise it won't load.
    set(TARGETDIR_LIB ${CMAKE_INSTALL_PREFIX_WITH_CONFIG}/bpy)
    set(TARGETDIR_EXE ${CMAKE_INSTALL_PREFIX_WITH_CONFIG}/bpy)
  else()
    set(TARGETDIR_VER "${BLENDER_VERSION}")
    set(TARGETDIR_TEXT ".")
    set(TARGETDIR_LIB "blender.shared")
    set(TARGETDIR_EXE ".")
  endif()
  set(TARGETDIR_SITE_PACKAGES "${TARGETDIR_VER}/python/lib/site-packages")
elseif(APPLE)
  if(WITH_PYTHON_MODULE)
    if(WITH_INSTALL_PORTABLE)
      set(TARGETDIR_BPY "bpy")
      set(TARGETDIR_VER "bpy/${BLENDER_VERSION}")
      set(TARGETDIR_LIB "bpy/lib")
    else()

=== source/blender/blenkernel/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  PUBLIC .
  ../ikplugin
  ../makesrna
  ../modifiers
  ../nodes/geometry/include
  ../shader_fx
  ../simulation
  ../windowmanager
  ../../../intern/eigen
  ../../../intern/ghost
  ../../../intern/iksolver/extern
  ../../../intern/libmv
  ../../../intern/mantaflow/extern
  ../../../intern/memutil
  ../../../intern/mikktspace
  ../../../intern/opensubdiv

  # RNA_prototypes.hh
  ${CMAKE_BINARY_DIR}/source/blender/makesrna
)

set(INC_SYS
  ${ZLIB_INCLUDE_DIRS}

  # For `vfontdata_freetype.cc`.
  ${FREETYPE_INCLUDE_DIRS}
)

set(SRC
  ${CMAKE_SOURCE_DIR}/release/datafiles/userdef/userdef_default.c
  intern/CCGSubSurf.cc
  intern/CCGSubSurf_legacy.cc
  intern/CCGSubSurf_util.cc
  intern/action.cc
  intern/action_bones.cc
  intern/action_mirror.cc
  intern/addon.cc
  intern/anim_data.cc
  intern/anim_path.cc
  intern/anim_sys.cc
  intern/anim_visualization.cc
  intern/anonymous_attribute_id.cc
  intern/appdir.cc
  intern/armature.cc
  intern/armature_deform.cc
  intern/armature_selection.cc
  intern/armature_update.cc
  intern/asset.cc
  intern/asset_edit.cc
  intern/asset_weak_reference.cc
  intern/attribute.cc
  intern/attribute_access.cc
  intern/attribute_math.cc
  intern/autoexec.cc
  intern/bake_data_block_map.cc
  intern/bake_geometry_nodes_modifier.cc
  intern/bake_geometry_nodes_modifier_pack.cc
  intern/bake_items.cc
  intern/bake_items_paths.cc
  intern/bake_items_serialize.cc
  intern/bake_items_socket.cc
  intern/blender.cc
  intern/blender_cli_command.cc
  intern/blender_copybuffer.cc
  intern/blender_undo.cc
  intern/blender_user_menu.cc
  intern/blendfile.cc
  intern/blendfile_link_append.cc
  intern/boids.cc
  intern/bpath.cc
  intern/brush.cc
  intern/bvhutils.cc
  intern/cachefile.cc
  intern/callbacks.cc
  intern/camera.cc
  intern/cloth.cc
  intern/collection.cc
  intern/collision.cc
  intern/colorband.cc
  intern/colortools.cc
  intern/compositor.cc
  intern/compute_contexts.cc
  intern/constraint.cc
  intern/context.cc
  intern/cpp_types.cc
  intern/crazyspace.cc
  intern/cryptomatte.cc
  intern/curve.cc
  intern/curve_bevel.cc
  intern/curve_bezier.cc
  intern/curve_catmull_rom.cc
  intern/curve_convert.cc
  intern/curve_decimate.cc
  intern/curve_deform.cc
  intern/curve_legacy_convert.cc
  intern/curve_nurbs.cc
  intern/curve_poly.cc
  intern/curve_to_mesh_convert.cc
  intern/curveprofile.cc
  intern/curves.cc
  intern/curves_attributes.cc
  intern/curves_geometry.cc
  intern/curves_utils.cc
  intern/customdata.cc
  intern/customdata_file.cc
  intern/data_transfer.cc
  intern/deform.cc
  intern/displist.cc
  intern/dynamicpaint.cc
  intern/editlattice.cc
  intern/editmesh.cc
  intern/editmesh_bvh.cc
  intern/editmesh_cache.cc
  intern/editmesh_tangent.cc
  intern/effect.cc
  intern/fcurve.cc
  intern/fcurve_cache.cc
  intern/fcurve_driver.cc
  intern/file_handler.cc
  intern/fluid.cc
  intern/fmodifier.cc
  intern/freestyle.cc
  intern/geometry_compare.cc
  intern/geometry_component_curves.cc
  intern/geometry_component_edit_data.cc
  intern/geometry_component_grease_pencil.cc
  intern/geometry_component_instances.cc
  intern/geometry_component_mesh.cc
  intern/geometry_component_pointcloud.cc
  intern/geometry_component_volume.cc
  intern/geometry_fields.cc
  intern/geometry_set.cc
  intern/geometry_set_instances.cc
  intern/gpencil_geom_legacy.cc
  intern/gpencil_legacy.cc
  intern/gpencil_modifier_legacy.cc
  intern/grease_pencil.cc
  intern/grease_pencil_attributes.cc
  intern/grease_pencil_convert_legacy.cc
  intern/grease_pencil_vertex_groups.cc
  intern/icons.cc
  intern/icons_rasterize.cc
  intern/idprop.cc
  intern/idprop_create.cc
  intern/idprop_serialize.cc
  intern/idprop_utils.cc
  intern/idtype.cc
  intern/image.cc
  intern/image_format.cc
  intern/image_gen.cc
  intern/image_gpu.cc
  intern/image_partial_update.cc
  intern/image_save.cc
  intern/instances.cc
  intern/instances_attributes.cc
  intern/ipo.cc
  intern/kelvinlet.cc
  intern/key.cc
  intern/keyconfig.cc
  intern/lattice.cc
  intern/lattice_deform.cc
  intern/layer.cc
  intern/layer_utils.cc
  intern/lib_id.cc
  intern/lib_id_delete.cc
  intern/lib_id_eval.cc
  intern/lib_id_remapper.cc
  intern/lib_override.cc
  intern/lib_override_proxy_conversion.cc
  intern/lib_query.cc
  intern/lib_remap.cc
  intern/library.cc
  intern/light.cc
  intern/light_linking.cc
  intern/lightprobe.cc
  intern/linestyle.cc
  intern/main.cc
  intern/main_idmap.cc
  intern/main_invariants.cc
  intern/main_namemap.cc
  intern/mask.cc
  intern/mask_evaluate.cc
  intern/mask_rasterize.cc
  intern/material.cc
  intern/mball.cc
  intern/mball_tessellate.cc
  intern/mesh.cc
  intern/mesh_attributes.cc
  intern/mesh_calc_edges.cc
  intern/mesh_convert.cc
  intern/mesh_data_update.cc
  intern/mesh_debug.cc
  intern/mesh_evaluate.cc
  intern/mesh_fair.cc
  intern/mesh_flip_faces.cc
  intern/mesh_iterators.cc
  intern/mesh_legacy_convert.cc
  intern/mesh_legacy_derived_mesh.cc
  intern/mesh_mapping.cc
  intern/mesh_merge_customdata.cc
  intern/mesh_mirror.cc
  intern/mesh_normals.cc
  intern/mesh_remap.cc
  intern/mesh_remesh_voxel.cc
  intern/mesh_runtime.cc
  intern/mesh_sample.cc
  intern/mesh_tangent.cc
  intern/mesh_topology_state.cc
  intern/mesh_tessellate.cc
  intern/mesh_validate.cc
  intern/mesh_wrapper.cc
  intern/modifier.cc
  intern/movieclip.cc
  intern/multires.cc
  intern/multires_reshape.cc
  intern/multires_reshape_apply_base.cc
  intern/multires_reshape_ccg.cc
  intern/multires_reshape_smooth.cc
  intern/multires_reshape_subdivide.cc
  intern/multires_reshape_util.cc
  intern/multires_reshape_vertcos.cc
  intern/multires_subdiv.cc
  intern/multires_unsubdivide.cc
  intern/multires_versioning.cc
  intern/nla.cc
  intern/node.cc
  intern/node_enum_definition.cc
  intern/node_runtime.cc
  intern/node_socket_value.cc
  intern/node_tree_dot_export.cc
  intern/node_tree_field_inferencing.cc
  intern/node_tree_interface.cc
  intern/node_tree_reference_lifetimes.cc
  intern/node_tree_update.cc
  intern/node_tree_zones.cc
  intern/object.cc
  intern/object_deform.cc
  intern/object_dupli.cc
  intern/object_update.cc
  intern/ocean.cc
  intern/ocean_spectrum.cc
  intern/outliner_treehash.cc
  intern/packedFile.cc
  intern/paint.cc
  intern/paint_canvas.cc
  intern/particle.cc
  intern/particle_child.cc
  intern/particle_distribute.cc
  intern/particle_system.cc
  intern/pbvh.cc
  intern/pbvh_bmesh.cc
  intern/pbvh_pixels.cc
  intern/pbvh_pixels_copy.cc
  intern/pbvh_uv_islands.cc
  intern/pointcache.cc
  intern/pointcloud.cc
  intern/pointcloud_attributes.cc
  intern/pose_backup.cc
  intern/preferences.cc
  intern/preview_image.cc
  intern/report.cc
  intern/rigidbody.cc
  intern/scene.cc
  intern/screen.cc
  intern/shader_fx.cc
  intern/shrinkwrap.cc
  intern/softbody.cc
  intern/sound.cc
  intern/speaker.cc
  intern/studiolight.cc
  intern/subdiv.cc
  intern/subdiv_ccg.cc
  intern/subdiv_ccg_mask.cc
  intern/subdiv_converter.cc
  intern/subdiv_converter_mesh.cc
  intern/subdiv_deform.cc
  intern/subdiv_displacement.cc
  intern/subdiv_displacement_multires.cc
  intern/subdiv_eval.cc
  intern/subdiv_foreach.cc
  intern/subdiv_mesh.cc
  intern/subdiv_modifier.cc
  intern/subdiv_stats.cc
  intern/subdiv_topology.cc
  intern/subsurf_ccg.cc
  intern/text.cc
  intern/text_suggestions.cc
  intern/texture.cc
  intern/tracking.cc
  intern/tracking_auto.cc
  intern/tracking_detect.cc
  intern/tracking_plane_tracker.cc
  intern/tracking_region_tracker.cc
  intern/tracking_solver.cc
  intern/tracking_stabilize.cc
  intern/tracking_util.cc
  intern/type_conversions.cc
  intern/undo_system.cc
  intern/unit.cc
  intern/vfont.cc
  intern/vfont_curve.cc
  intern/vfontdata_freetype.cc
  intern/viewer_path.cc
  intern/volume.cc
  intern/volume_grid.cc
  intern/volume_grid_file_cache.cc
  intern/volume_render.cc
  intern/volume_to_mesh.cc
  intern/wm_runtime.cc
  intern/workspace.cc
  intern/world.cc

  BKE_action.hh
  BKE_addon.h
  BKE_anim_data.hh
  BKE_anim_path.h
  BKE_anim_visualization.h
  BKE_animsys.h
  BKE_anonymous_attribute_id.hh
  BKE_anonymous_attribute_make.hh
  BKE_appdir.hh
  BKE_armature.hh
  BKE_asset.hh
  BKE_asset_edit.hh
  BKE_attribute.h
  BKE_attribute.hh
  BKE_attribute_filter.hh
  BKE_attribute_filters.hh
  BKE_attribute_math.hh
  BKE_autoexec.hh
  BKE_bake_data_block_id.hh
  BKE_bake_data_block_map.hh
  BKE_bake_geometry_nodes_modifier.hh
  BKE_bake_geometry_nodes_modifier_pack.hh
  BKE_bake_items.hh
  BKE_bake_items_paths.hh
  BKE_bake_items_serialize.hh
  BKE_bake_items_socket.hh
  BKE_blender.hh
  BKE_blender_cli_command.hh
  BKE_blender_copybuffer.hh
  BKE_blender_undo.hh
  BKE_blender_user_menu.hh
  BKE_blender_version.h
  BKE_blendfile.hh
  BKE_blendfile_link_append.hh
  BKE_boids.h
  BKE_bpath.hh
  BKE_brush.hh
  BKE_bvhutils.hh
  BKE_cachefile.hh
  BKE_callbacks.hh
  BKE_camera.h
  BKE_ccg.hh
  BKE_cloth.hh
  BKE_collection.hh
  BKE_collision.h
  BKE_colorband.hh
  BKE_colortools.hh
  BKE_compositor.hh
  BKE_compute_contexts.hh
  BKE_constraint.h
  BKE_context.hh
  BKE_cpp_types.hh
  BKE_crazyspace.hh
  BKE_cryptomatte.h
  BKE_cryptomatte.hh
  BKE_curve.hh
  BKE_curve_legacy_convert.hh
  BKE_curve_to_mesh.hh
  BKE_curveprofile.h
  BKE_curves.h
  BKE_curves.hh
  BKE_curves_utils.hh
  BKE_customdata.hh
  BKE_customdata_file.h
  BKE_data_transfer.h
  BKE_deform.hh
  BKE_displist.h
  BKE_duplilist.hh
  BKE_dynamicpaint.h
  BKE_editlattice.h
  BKE_editmesh.hh
  BKE_editmesh_bvh.hh
  BKE_editmesh_cache.hh
  BKE_editmesh_tangent.hh
  BKE_effect.h
  BKE_fcurve.hh
  BKE_fcurve_driver.h
  BKE_file_handler.hh
  BKE_fluid.h
  BKE_freestyle.h
  BKE_geometry_compare.hh
  BKE_geometry_fields.hh
  BKE_geometry_nodes_gizmos_transforms.hh
  BKE_geometry_nodes_reference_set.hh
  BKE_geometry_set.hh
  BKE_geometry_set_instances.hh
  BKE_global.hh
  BKE_gpencil_geom_legacy.h
  BKE_gpencil_legacy.h
  BKE_gpencil_modifier_legacy.h
  BKE_grease_pencil.h
  BKE_grease_pencil.hh
  BKE_grease_pencil_legacy_convert.hh
  BKE_grease_pencil_vertex_groups.hh
  BKE_icons.h
  BKE_idprop.hh
  BKE_idtype.hh
  BKE_image.hh
  BKE_image_format.hh
  BKE_image_partial_update.hh
  BKE_image_save.hh
  BKE_image_wrappers.hh
  BKE_instances.hh
  BKE_ipo.h
  BKE_kelvinlet.h
  BKE_key.hh
  BKE_keyconfig.h
  BKE_lattice.hh
  BKE_layer.hh
  BKE_lib_id.hh
  BKE_lib_override.hh
  BKE_lib_query.hh
  BKE_lib_remap.hh
  BKE_library.hh
  BKE_light.h
  BKE_light_linking.h
  BKE_lightprobe.h
  BKE_linestyle.h
  BKE_main.hh
  BKE_main_idmap.hh
  BKE_main_invariants.hh
  BKE_main_namemap.hh
  BKE_mask.h
  BKE_material.hh
  BKE_mball.hh
  BKE_mball_tessellate.hh
  BKE_mesh.h
  BKE_mesh.hh
  BKE_mesh_fair.hh
  BKE_mesh_iterators.hh
  BKE_mesh_legacy_convert.hh
  BKE_mesh_legacy_derived_mesh.hh
  BKE_mesh_mapping.hh
  BKE_mesh_mirror.hh
  BKE_mesh_remap.hh
  BKE_mesh_remesh_voxel.hh
  BKE_mesh_runtime.hh
  BKE_mesh_sample.hh
  BKE_mesh_tangent.hh
  BKE_mesh_topology_state.hh
  BKE_mesh_types.hh
  BKE_mesh_wrapper.hh
  BKE_modifier.hh
  BKE_movieclip.h
  BKE_multires.hh
  BKE_nla.hh
  BKE_node.hh
  BKE_node_enum.hh
  BKE_node_legacy_types.hh
  BKE_node_runtime.hh
  BKE_node_socket_value.hh
  BKE_node_tree_dot_export.hh
  BKE_node_tree_interface.hh
  BKE_node_tree_reference_lifetimes.hh
  BKE_node_tree_update.hh
  BKE_node_tree_zones.hh
  BKE_object.hh
  BKE_object_deform.h
  BKE_object_types.hh
  BKE_ocean.h
  BKE_outliner_treehash.hh
  BKE_packedFile.hh
  BKE_paint.hh
  BKE_paint_bvh.hh
  BKE_paint_bvh_pixels.hh
  BKE_particle.h
  BKE_pointcache.h
  BKE_pointcloud.hh
  BKE_pose_backup.h
  BKE_preferences.h
  BKE_preview_image.hh
  BKE_report.hh
  BKE_rigidbody.h
  BKE_scene.hh
  BKE_scene_runtime.hh
  BKE_screen.hh
  BKE_sequencer_offscreen.h
  BKE_shader_fx.h
  BKE_shrinkwrap.hh
  BKE_softbody.h
  BKE_sound.h
  BKE_speaker.h
  BKE_studiolight.h
  BKE_subdiv.hh
  BKE_subdiv_ccg.hh
  BKE_subdiv_deform.hh
  BKE_subdiv_eval.hh

=== source/blender/compositor/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2011-2024 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  .
  algorithms
  cached_resources
  derived_resources
  utilities
  ../gpu/intern
  ../makesrna
  ../render/intern
)

set(INC_SYS

)

set(SRC
  COM_compile_state.hh
  COM_compositor.hh
  COM_context.hh
  COM_conversion_operation.hh
  COM_derived_resources.hh
  COM_domain.hh
  COM_evaluator.hh
  COM_input_descriptor.hh
  COM_input_single_value_operation.hh
  COM_meta_data.hh
  COM_multi_function_procedure_operation.hh
  COM_node_operation.hh
  COM_operation.hh
  COM_pixel_operation.hh
  COM_profiler.hh
  COM_realize_on_domain_operation.hh
  COM_reduce_to_single_value_operation.hh
  COM_render_context.hh
  COM_result.hh
  COM_scheduler.hh
  COM_shader_node.hh
  COM_shader_operation.hh
  COM_simple_operation.hh
  COM_static_cache_manager.hh
  COM_texture_pool.hh
  COM_utilities.hh

  intern/COM_compositor.cc
  intern/compile_state.cc
  intern/context.cc
  intern/conversion_operation.cc
  intern/domain.cc
  intern/evaluator.cc
  intern/input_single_value_operation.cc
  intern/meta_data.cc
  intern/multi_function_procedure_operation.cc
  intern/node_operation.cc
  intern/operation.cc
  intern/pixel_operation.cc
  intern/profiler.cc
  intern/realize_on_domain_operation.cc
  intern/reduce_to_single_value_operation.cc
  intern/render_context.cc
  intern/result.cc
  intern/scheduler.cc
  intern/shader_node.cc
  intern/shader_operation.cc
  intern/simple_operation.cc
  intern/static_cache_manager.cc
  intern/texture_pool.cc
  intern/utilities.cc

  algorithms/intern/compute_preview.cc
  algorithms/intern/deriche_gaussian_blur.cc
  algorithms/intern/extract_alpha.cc
  algorithms/intern/gamma_correct.cc
  algorithms/intern/jump_flooding.cc
  algorithms/intern/morphological_blur.cc
  algorithms/intern/morphological_distance.cc
  algorithms/intern/morphological_distance_feather.cc
  algorithms/intern/parallel_reduction.cc
  algorithms/intern/recursive_gaussian_blur.cc
  algorithms/intern/smaa.cc
  algorithms/intern/summed_area_table.cc
  algorithms/intern/symmetric_separable_blur.cc
  algorithms/intern/symmetric_separable_blur_variable_size.cc
  algorithms/intern/van_vliet_gaussian_blur.cc

  algorithms/COM_algorithm_compute_preview.hh
  algorithms/COM_algorithm_deriche_gaussian_blur.hh
  algorithms/COM_algorithm_extract_alpha.hh
  algorithms/COM_algorithm_gamma_correct.hh
  algorithms/COM_algorithm_jump_flooding.hh
  algorithms/COM_algorithm_morphological_blur.hh
  algorithms/COM_algorithm_morphological_distance.hh
  algorithms/COM_algorithm_morphological_distance_feather.hh
  algorithms/COM_algorithm_parallel_reduction.hh
  algorithms/COM_algorithm_recursive_gaussian_blur.hh
  algorithms/COM_algorithm_smaa.hh
  algorithms/COM_algorithm_summed_area_table.hh
  algorithms/COM_algorithm_symmetric_separable_blur.hh
  algorithms/COM_algorithm_symmetric_separable_blur_variable_size.hh
  algorithms/COM_algorithm_van_vliet_gaussian_blur.hh

  cached_resources/intern/bokeh_kernel.cc
  cached_resources/intern/cached_image.cc
  cached_resources/intern/cached_mask.cc
  cached_resources/intern/cached_shader.cc
  cached_resources/intern/cached_texture.cc
  cached_resources/intern/deriche_gaussian_coefficients.cc
  cached_resources/intern/distortion_grid.cc
  cached_resources/intern/fog_glow_kernel.cc
  cached_resources/intern/keying_screen.cc
  cached_resources/intern/morphological_distance_feather_weights.cc
  cached_resources/intern/ocio_color_space_conversion_shader.cc
  cached_resources/intern/smaa_precomputed_textures.cc
  cached_resources/intern/symmetric_blur_weights.cc
  cached_resources/intern/symmetric_separable_blur_weights.cc
  cached_resources/intern/van_vliet_gaussian_coefficients.cc

  cached_resources/COM_bokeh_kernel.hh
  cached_resources/COM_cached_image.hh
  cached_resources/COM_cached_mask.hh
  cached_resources/COM_cached_resource.hh
  cached_resources/COM_cached_shader.hh
  cached_resources/COM_cached_texture.hh
  cached_resources/COM_deriche_gaussian_coefficients.hh
  cached_resources/COM_distortion_grid.hh
  cached_resources/COM_fog_glow_kernel.hh
  cached_resources/COM_keying_screen.hh
  cached_resources/COM_morphological_distance_feather_weights.hh
  cached_resources/COM_ocio_color_space_conversion_shader.hh
  cached_resources/COM_smaa_precomputed_textures.hh
  cached_resources/COM_symmetric_blur_weights.hh
  cached_resources/COM_symmetric_separable_blur_weights.hh
  cached_resources/COM_van_vliet_gaussian_coefficients.hh

  derived_resources/intern/denoised_auxiliary_pass.cc

  derived_resources/COM_denoised_auxiliary_pass.hh

  utilities/COM_utilities_diagonals.hh
  utilities/COM_utilities_type_conversion.hh
)

set(LIB
  PRIVATE bf::blenkernel
  PRIVATE bf::blentranslation
  PRIVATE bf::functions
  PRIVATE bf::gpu
  PRIVATE bf::imbuf
  PRIVATE bf::nodes
  PRIVATE bf::render
  PRIVATE bf::blenlib
  PRIVATE bf::dna
  PRIVATE bf::intern::guardedalloc
)

set(GLSL_SRC
  shaders/compositor_alpha_crop.glsl
  shaders/compositor_bilateral_blur.glsl
  shaders/compositor_bokeh_blur.glsl
  shaders/compositor_bokeh_blur_variable_size.glsl
  shaders/compositor_bokeh_image.glsl
  shaders/compositor_box_mask.glsl
  shaders/compositor_compute_preview.glsl
  shaders/compositor_convert.glsl
  shaders/compositor_cryptomatte_image.glsl
  shaders/compositor_cryptomatte_matte.glsl
  shaders/compositor_cryptomatte_pick.glsl
  shaders/compositor_defocus_blur.glsl
  shaders/compositor_defocus_radius_from_depth.glsl
  shaders/compositor_defocus_radius_from_scale.glsl
  shaders/compositor_despeckle.glsl
  shaders/compositor_deriche_gaussian_blur.glsl
  shaders/compositor_deriche_gaussian_blur_sum.glsl
  shaders/compositor_directional_blur.glsl
  shaders/compositor_displace.glsl
  shaders/compositor_double_edge_mask_compute_boundary.glsl
  shaders/compositor_double_edge_mask_compute_gradient.glsl
  shaders/compositor_edge_filter.glsl
  shaders/compositor_ellipse_mask.glsl
  shaders/compositor_filter.glsl
  shaders/compositor_flip.glsl
  shaders/compositor_gamma_correct.glsl
  shaders/compositor_glare_bloom_downsample.glsl
  shaders/compositor_glare_bloom_upsample.glsl
  shaders/compositor_glare_ghost_accumulate.glsl
  shaders/compositor_glare_ghost_base.glsl
  shaders/compositor_glare_highlights.glsl
  shaders/compositor_glare_mix.glsl
  shaders/compositor_glare_simple_star_anti_diagonal_pass.glsl
  shaders/compositor_glare_simple_star_diagonal_pass.glsl
  shaders/compositor_glare_simple_star_horizontal_pass.glsl
  shaders/compositor_glare_simple_star_vertical_pass.glsl
  shaders/compositor_glare_streaks_accumulate.glsl
  shaders/compositor_glare_streaks_filter.glsl
  shaders/compositor_glare_write_glare_output.glsl
  shaders/compositor_glare_write_highlights_output.glsl
  shaders/compositor_id_mask.glsl
  shaders/compositor_image_crop.glsl
  shaders/compositor_inpaint_compute_boundary.glsl
  shaders/compositor_inpaint_compute_region.glsl
  shaders/compositor_inpaint_fill_region.glsl
  shaders/compositor_jump_flooding.glsl
  shaders/compositor_keying_compute_image.glsl
  shaders/compositor_keying_compute_matte.glsl
  shaders/compositor_keying_extract_chroma.glsl
  shaders/compositor_keying_replace_chroma.glsl
  shaders/compositor_keying_screen.glsl
  shaders/compositor_keying_tweak_matte.glsl
  shaders/compositor_kuwahara_anisotropic.glsl
  shaders/compositor_kuwahara_anisotropic_compute_structure_tensor.glsl
  shaders/compositor_kuwahara_classic.glsl
  shaders/compositor_map_uv_anisotropic.glsl
  shaders/compositor_map_uv_nearest_neighbour.glsl
  shaders/compositor_morphological_blur.glsl
  shaders/compositor_morphological_distance.glsl
  shaders/compositor_morphological_distance_feather.glsl
  shaders/compositor_morphological_distance_threshold.glsl
  shaders/compositor_morphological_step.glsl
  shaders/compositor_motion_blur.glsl
  shaders/compositor_motion_blur_max_velocity_dilate.glsl
  shaders/compositor_movie_distortion.glsl
  shaders/compositor_normalize.glsl
  shaders/compositor_parallel_reduction.glsl
  shaders/compositor_pixelate.glsl
  shaders/compositor_plane_deform.glsl
  shaders/compositor_plane_deform_mask.glsl
  shaders/compositor_plane_deform_motion_blur.glsl
  shaders/compositor_plane_deform_motion_blur_mask.glsl
  shaders/compositor_premultiply_alpha.glsl
  shaders/compositor_projector_lens_distortion.glsl
  shaders/compositor_read_input.glsl
  shaders/compositor_realize_on_domain.glsl
  shaders/compositor_scale_variable.glsl
  shaders/compositor_screen_lens_distortion.glsl
  shaders/compositor_smaa_blending_weight_calculation.glsl
  shaders/compositor_smaa_edge_detection.glsl
  shaders/compositor_smaa_neighborhood_blending.glsl
  shaders/compositor_split.glsl
  shaders/compositor_summed_area_table_compute_complete_blocks.glsl
  shaders/compositor_summed_area_table_compute_complete_x_prologues.glsl
  shaders/compositor_summed_area_table_compute_complete_y_prologues.glsl
  shaders/compositor_summed_area_table_compute_incomplete_prologues.glsl
  shaders/compositor_sun_beams.glsl
  shaders/compositor_symmetric_blur.glsl
  shaders/compositor_symmetric_blur_variable_size.glsl
  shaders/compositor_symmetric_separable_blur.glsl
  shaders/compositor_symmetric_separable_blur_variable_size.glsl
  shaders/compositor_tone_map_photoreceptor.glsl
  shaders/compositor_tone_map_simple.glsl
  shaders/compositor_translate_wrapped.glsl
  shaders/compositor_van_vliet_gaussian_blur.glsl
  shaders/compositor_van_vliet_gaussian_blur_sum.glsl
  shaders/compositor_write_output.glsl
  shaders/compositor_z_combine_compute_mask.glsl
  shaders/compositor_z_combine_from_mask.glsl
  shaders/compositor_z_combine_simple.glsl

  shaders/library/gpu_shader_compositor_alpha_over.glsl
  shaders/library/gpu_shader_compositor_bright_contrast.glsl
  shaders/library/gpu_shader_compositor_channel_matte.glsl
  shaders/library/gpu_shader_compositor_chroma_matte.glsl
  shaders/library/gpu_shader_compositor_color_balance.glsl
  shaders/library/gpu_shader_compositor_color_correction.glsl
  shaders/library/gpu_shader_compositor_color_matte.glsl
  shaders/library/gpu_shader_compositor_color_spill.glsl
  shaders/library/gpu_shader_compositor_color_to_luminance.glsl
  shaders/library/gpu_shader_compositor_difference_matte.glsl
  shaders/library/gpu_shader_compositor_distance_matte.glsl
  shaders/library/gpu_shader_compositor_exposure.glsl
  shaders/library/gpu_shader_compositor_gamma.glsl
  shaders/library/gpu_shader_compositor_hue_correct.glsl
  shaders/library/gpu_shader_compositor_hue_saturation_value.glsl
  shaders/library/gpu_shader_compositor_image_diagonals.glsl
  shaders/library/gpu_shader_compositor_invert.glsl
  shaders/library/gpu_shader_compositor_jump_flooding_lib.glsl
  shaders/library/gpu_shader_compositor_luminance_matte.glsl
  shaders/library/gpu_shader_compositor_main.glsl
  shaders/library/gpu_shader_compositor_map_value.glsl
  shaders/library/gpu_shader_compositor_motion_blur_lib.glsl
  shaders/library/gpu_shader_compositor_normal.glsl
  shaders/library/gpu_shader_compositor_ocio_processor.glsl
  shaders/library/gpu_shader_compositor_posterize.glsl
  shaders/library/gpu_shader_compositor_separate_combine.glsl
  shaders/library/gpu_shader_compositor_set_alpha.glsl
  shaders/library/gpu_shader_compositor_store_output.glsl
  shaders/library/gpu_shader_compositor_summed_area_table_lib.glsl
  shaders/library/gpu_shader_compositor_texture_utilities.glsl
  shaders/library/gpu_shader_compositor_type_conversion.glsl
)

set(GLSL_C)
foreach(GLSL_FILE ${GLSL_SRC})
  glsl_to_c(${GLSL_FILE} GLSL_C)
endforeach()

blender_add_lib(bf_compositor_shaders "${GLSL_C}" "" "" "")

list(APPEND LIB
  bf_compositor_shaders
)

set(GLSL_SOURCE_CONTENT "")
foreach(GLSL_FILE ${GLSL_SRC})
  get_filename_component(GLSL_FILE_NAME ${GLSL_FILE} NAME)
  string(REPLACE "." "_" GLSL_FILE_NAME_UNDERSCORES ${GLSL_FILE_NAME})

=== source/blender/depsgraph/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2014 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  PUBLIC .
  ../animrig
  ../makesrna
  ../modifiers
  # RNA_prototypes.hh
  ${CMAKE_BINARY_DIR}/source/blender/makesrna
)

set(INC_SYS
)

set(SRC
  intern/builder/deg_builder.cc
  intern/builder/deg_builder_cache.cc
  intern/builder/deg_builder_cycle.cc
  intern/builder/deg_builder_key.cc
  intern/builder/deg_builder_key.h
  intern/builder/deg_builder_map.cc
  intern/builder/deg_builder_nodes.cc
  intern/builder/deg_builder_nodes_rig.cc
  intern/builder/deg_builder_nodes_scene.cc
  intern/builder/deg_builder_nodes_view_layer.cc
  intern/builder/deg_builder_pchanmap.cc
  intern/builder/deg_builder_relations.cc
  intern/builder/deg_builder_relations_drivers.cc
  intern/builder/deg_builder_relations_rig.cc
  intern/builder/deg_builder_relations_scene.cc
  intern/builder/deg_builder_relations_view_layer.cc
  intern/builder/deg_builder_remove_noop.cc
  intern/builder/deg_builder_rna.cc
  intern/builder/deg_builder_stack.cc
  intern/builder/deg_builder_transitive.cc
  intern/builder/pipeline.cc
  intern/builder/pipeline_all_objects.cc
  intern/builder/pipeline_compositor.cc
  intern/builder/pipeline_from_collection.cc
  intern/builder/pipeline_from_ids.cc
  intern/builder/pipeline_render.cc
  intern/builder/pipeline_view_layer.cc
  intern/debug/deg_debug.cc
  intern/debug/deg_debug_relations_graphviz.cc
  intern/debug/deg_debug_stats_gnuplot.cc
  intern/eval/deg_eval.cc
  intern/eval/deg_eval_copy_on_write.cc
  intern/eval/deg_eval_flush.cc
  intern/eval/deg_eval_runtime_backup.cc
  intern/eval/deg_eval_runtime_backup_animation.cc
  intern/eval/deg_eval_runtime_backup_modifier.cc
  intern/eval/deg_eval_runtime_backup_movieclip.cc
  intern/eval/deg_eval_runtime_backup_object.cc
  intern/eval/deg_eval_runtime_backup_pose.cc
  intern/eval/deg_eval_runtime_backup_scene.cc
  intern/eval/deg_eval_runtime_backup_sequence.cc
  intern/eval/deg_eval_runtime_backup_sequencer.cc
  intern/eval/deg_eval_runtime_backup_sound.cc
  intern/eval/deg_eval_runtime_backup_volume.cc
  intern/eval/deg_eval_stats.cc
  intern/eval/deg_eval_visibility.cc
  intern/eval/deg_eval_visibility.h
  intern/node/deg_node.cc
  intern/node/deg_node_component.cc
  intern/node/deg_node_factory.cc
  intern/node/deg_node_id.cc
  intern/node/deg_node_operation.cc
  intern/node/deg_node_time.cc
  intern/depsgraph.cc
  intern/depsgraph_build.cc
  intern/depsgraph_debug.cc
  intern/depsgraph_eval.cc
  intern/depsgraph_light_linking.cc
  intern/depsgraph_light_linking.hh
  intern/depsgraph_physics.cc
  intern/depsgraph_query.cc
  intern/depsgraph_query_foreach.cc
  intern/depsgraph_query_iter.cc
  intern/depsgraph_registry.cc
  intern/depsgraph_relation.cc
  intern/depsgraph_tag.cc
  intern/depsgraph_type.cc
  intern/depsgraph_update.cc
  intern/depsgraph_writeback_sync.cc

  DEG_depsgraph.hh
  DEG_depsgraph_build.hh
  DEG_depsgraph_debug.hh
  DEG_depsgraph_light_linking.hh
  DEG_depsgraph_physics.hh
  DEG_depsgraph_query.hh
  DEG_depsgraph_writeback_sync.hh

  intern/builder/deg_builder.h
  intern/builder/deg_builder_cache.h
  intern/builder/deg_builder_cycle.h
  intern/builder/deg_builder_map.h
  intern/builder/deg_builder_nodes.h
  intern/builder/deg_builder_pchanmap.h
  intern/builder/deg_builder_relations.h
  intern/builder/deg_builder_relations_drivers.h
  intern/builder/deg_builder_relations_impl.h
  intern/builder/deg_builder_remove_noop.h
  intern/builder/deg_builder_rna.h
  intern/builder/deg_builder_stack.h
  intern/builder/deg_builder_transitive.h
  intern/builder/pipeline.h
  intern/builder/pipeline_all_objects.h
  intern/builder/pipeline_compositor.h
  intern/builder/pipeline_from_collection.h
  intern/builder/pipeline_from_ids.h
  intern/builder/pipeline_render.h
  intern/builder/pipeline_view_layer.h
  intern/debug/deg_debug.h
  intern/eval/deg_eval.h
  intern/eval/deg_eval_copy_on_write.h
  intern/eval/deg_eval_flush.h
  intern/eval/deg_eval_runtime_backup.h
  intern/eval/deg_eval_runtime_backup_animation.h
  intern/eval/deg_eval_runtime_backup_modifier.h
  intern/eval/deg_eval_runtime_backup_movieclip.h
  intern/eval/deg_eval_runtime_backup_object.h
  intern/eval/deg_eval_runtime_backup_pose.h
  intern/eval/deg_eval_runtime_backup_scene.h
  intern/eval/deg_eval_runtime_backup_sequence.h
  intern/eval/deg_eval_runtime_backup_sequencer.h
  intern/eval/deg_eval_runtime_backup_sound.h
  intern/eval/deg_eval_runtime_backup_volume.h
  intern/eval/deg_eval_stats.h
  intern/node/deg_node.hh
  intern/node/deg_node_component.hh
  intern/node/deg_node_factory.hh
  intern/node/deg_node_factory_impl.hh
  intern/node/deg_node_id.hh
  intern/node/deg_node_operation.hh
  intern/node/deg_node_time.hh
  intern/depsgraph.hh
  intern/depsgraph_physics.hh
  intern/depsgraph_registry.hh
  intern/depsgraph_relation.hh
  intern/depsgraph_tag.hh
  intern/depsgraph_type.hh
  intern/depsgraph_update.hh
)

set(LIB
  PRIVATE bf::blenkernel
  PRIVATE bf::blenlib
  PRIVATE bf::bmesh
  PRIVATE bf::dna
  PRIVATE bf::draw
  PRIVATE bf::functions
  PRIVATE bf::intern::atomic
  PRIVATE bf::intern::guardedalloc
  PRIVATE bf::sequencer
  PRIVATE bf::windowmanager
)

if(WITH_PYTHON)
  add_definitions(-DWITH_PYTHON)
  list(APPEND INC
    ../python
  )
endif()

blender_add_lib(bf_depsgraph "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")
add_library(bf::depsgraph ALIAS bf_depsgraph)

# RNA_prototypes.hh
add_dependencies(bf_depsgraph bf_rna)

if(WITH_GTESTS)
  set(TEST_INC
  )
  set(TEST_SRC
    intern/builder/deg_builder_rna_test.cc
  )
  set(TEST_LIB
    bf_depsgraph
  )
  blender_add_test_suite_lib(depsgraph "${TEST_SRC}" "${INC};${TEST_INC}" "${INC_SYS}" "${LIB}")
endif()

=== source/blender/geometry/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  PUBLIC .
  ../makesrna
  ../../../intern/eigen
)

set(INC_SYS
)

set(SRC
  intern/add_curves_on_mesh.cc
  intern/curve_constraints.cc
  intern/extend_curves.cc
  intern/extract_elements.cc
  intern/fillet_curves.cc
  intern/interpolate_curves.cc
  intern/join_geometries.cc
  intern/merge_curves.cc
  intern/merge_layers.cc
  intern/mesh_boolean.cc
  intern/mesh_copy_selection.cc
  intern/mesh_merge_by_distance.cc
  intern/mesh_primitive_cuboid.cc
  intern/mesh_primitive_cylinder_cone.cc
  intern/mesh_primitive_grid.cc
  intern/mesh_primitive_line.cc
  intern/mesh_primitive_uv_sphere.cc
  intern/mesh_selection.cc
  intern/mesh_split_edges.cc
  intern/mesh_to_curve_convert.cc
  intern/mesh_to_volume.cc
  intern/mesh_triangulate.cc
  intern/mix_geometries.cc
  intern/point_merge_by_distance.cc
  intern/points_to_volume.cc
  intern/randomize.cc
  intern/realize_instances.cc
  intern/reorder.cc
  intern/resample_curves.cc
  intern/reverse_uv_sampler.cc
  intern/separate_geometry.cc
  intern/set_curve_type.cc
  intern/simplify_curves.cc
  intern/smooth_curves.cc
  intern/subdivide_curves.cc
  intern/transform.cc
  intern/trim_curves.cc
  intern/uv_pack.cc
  intern/uv_parametrizer.cc
  intern/volume_grid_resample.cc

  GEO_add_curves_on_mesh.hh
  GEO_curve_constraints.hh
  GEO_extend_curves.hh
  GEO_extract_elements.hh
  GEO_fillet_curves.hh
  GEO_interpolate_curves.hh
  GEO_join_geometries.hh
  GEO_merge_curves.hh
  GEO_merge_layers.hh
  GEO_mesh_boolean.hh
  GEO_mesh_copy_selection.hh
  GEO_mesh_merge_by_distance.hh
  GEO_mesh_primitive_cuboid.hh
  GEO_mesh_primitive_cylinder_cone.hh
  GEO_mesh_primitive_grid.hh
  GEO_mesh_primitive_line.hh
  GEO_mesh_primitive_uv_sphere.hh
  GEO_mesh_selection.hh
  GEO_mesh_split_edges.hh
  GEO_mesh_to_curve.hh
  GEO_mesh_to_volume.hh
  GEO_mesh_triangulate.hh
  GEO_mix_geometries.hh
  GEO_point_merge_by_distance.hh
  GEO_points_to_volume.hh
  GEO_randomize.hh
  GEO_realize_instances.hh
  GEO_reorder.hh
  GEO_resample_curves.hh
  GEO_reverse_uv_sampler.hh
  GEO_separate_geometry.hh
  GEO_set_curve_type.hh
  GEO_simplify_curves.hh
  GEO_smooth_curves.hh
  GEO_subdivide_curves.hh
  GEO_transform.hh
  GEO_trim_curves.hh
  GEO_uv_pack.hh
  GEO_uv_parametrizer.hh
  GEO_volume_grid_resample.hh
)

set(LIB
  PRIVATE bf::blenkernel
  PRIVATE bf::blenlib
  PRIVATE bf::blentranslation
  PRIVATE bf::bmesh
  PRIVATE bf::dna
  PRIVATE bf::functions
  PRIVATE bf::intern::atomic
  PRIVATE bf::intern::guardedalloc
  PRIVATE bf::extern::fmtlib
)

if(WITH_UV_SLIM)
  list(APPEND INC
    ../../../intern/slim
  )
  add_definitions(-DWITH_UV_SLIM)
endif()

if(WITH_OPENVDB)
  list(APPEND INC
    ../../../intern/openvdb
  )
  list(APPEND INC_SYS
    ${OPENVDB_INCLUDE_DIRS}
  )
  list(APPEND LIB
    bf_intern_openvdb
    ${OPENVDB_LIBRARIES}
  )
  add_definitions(-DWITH_OPENVDB ${OPENVDB_DEFINITIONS})
endif()

if(WITH_GMP)
  add_definitions(-DWITH_GMP)

  list(APPEND INC_SYS
    ${GMP_INCLUDE_DIRS}
  )

  list(APPEND LIB
    ${GMP_LIBRARIES}
  )
endif()

blender_add_lib(bf_geometry "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")
add_library(bf::geometry ALIAS bf_geometry)

if(WITH_GTESTS)
  set(TEST_INC
  )
  set(TEST_SRC
    tests/GEO_merge_curves_test.cc
  )
  set(TEST_LIB
  )
  blender_add_test_suite_lib(bf_geometry_tests "${TEST_SRC}" "${INC};${TEST_INC}" "${INC_SYS}" "${LIB};${TEST_LIB}")
endif()

=== source/blender/imbuf/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

add_subdirectory(movie)

set(INC
  PUBLIC .
  ./movie
  ../makesrna
  ../../../intern/memutil
)

set(INC_SYS
  ${JPEG_INCLUDE_DIR}
  ${ZLIB_INCLUDE_DIRS}
  ${OPENIMAGEIO_INCLUDE_DIRS}
)

set(SRC
  intern/allocimbuf.cc
  intern/colormanagement.cc
  intern/colormanagement_inline.h
  intern/divers.cc
  intern/filetype.cc
  intern/filter.cc
  intern/format_bmp.cc
  intern/format_dds.cc
  intern/format_hdr.cc
  intern/format_png.cc
  intern/format_psd.cc
  intern/format_svg.cc
  intern/format_targa.cc
  intern/format_tiff.cc
  intern/imageprocess.cc
  intern/interp.cc
  intern/iris.cc
  intern/jpeg.cc
  intern/metadata.cc
  intern/module.cc
  intern/moviecache.cc
  intern/readimage.cc
  intern/rectop.cc
  intern/rotate.cc
  intern/scaling.cc
  intern/stereoimbuf.cc
  intern/thumbs.cc
  intern/thumbs_blend.cc
  intern/thumbs_font.cc
  intern/transform.cc
  intern/util.cc
  intern/util_gpu.cc
  intern/writeimage.cc

  IMB_colormanagement.hh
  IMB_imbuf.hh
  IMB_imbuf_enums.h
  IMB_imbuf_types.hh
  IMB_interp.hh
  IMB_metadata.hh
  IMB_moviecache.hh
  IMB_openexr.hh
  IMB_thumbs.hh
  intern/IMB_allocimbuf.hh
  intern/IMB_colormanagement_intern.hh
  intern/IMB_filetype.hh
  intern/IMB_filter.hh
  intern/imbuf.hh
)

set(LIB
  PRIVATE bf::blenkernel
  PRIVATE bf::blenlib
  PRIVATE bf::blenloader
  PRIVATE bf::dna
  PRIVATE bf::gpu
  bf_imbuf_openimageio
  PRIVATE bf::intern::guardedalloc
  bf_intern_memutil
  bf_intern_opencolorio
  PRIVATE bf::extern::nanosvg

  ${JPEG_LIBRARIES}
  PRIVATE bf::sequencer
)

if(WITH_IMAGE_OPENEXR)
  list(APPEND LIB
    bf_imbuf_openexr
  )
  add_definitions(-DWITH_OPENEXR)
else()
  list(APPEND SRC
    intern/openexr/openexr_stub.cpp
  )
endif()

# OpenImageIO headers include `Imath` headers when there is no SSE support for
# matrix operations. This depends on the specific architecture and compiler
# flags, most reliable is to always include the `Imath` headers if we have them.
if(DEFINED IMATH_INCLUDE_DIRS)
  list(APPEND INC_SYS
    ${IMATH_INCLUDE_DIRS}
  )
endif()

if(WITH_IMAGE_OPENJPEG)
  list(APPEND INC_SYS
    ${OPENJPEG_INCLUDE_DIRS}
  )
  list(APPEND SRC
    intern/jp2.cc
  )
  list(APPEND LIB
    ${OPENJPEG_LIBRARIES}
  )

  add_definitions(-DWITH_OPENJPEG ${OPENJPEG_DEFINES})
endif()

if(WITH_IMAGE_CINEON)
  list(APPEND SRC
    intern/format_dpx.cc
  )
  list(APPEND LIB
    bf_imbuf_cineon
  )
  add_definitions(-DWITH_CINEON)
endif()

if(WITH_IMAGE_WEBP)
  list(APPEND SRC
    intern/webp.cc
  )
  list(APPEND INC_SYS
    ${WEBP_INCLUDE_DIRS}
  )
  list(APPEND LIB
    ${WEBP_LIBRARIES}
  )
  add_definitions(-DWITH_WEBP)
endif()

list(APPEND INC
  ../../../intern/opencolorio
)

if(WIN32)
  list(APPEND INC
    ../../../intern/utfconv
  )
endif()

if(WIN32)
  add_definitions(-DNOMINMAX)
endif()

# no need to compile object files for inline headers.
set_source_files_properties(
  intern/colormanagement_inline.cc
  PROPERTIES HEADER_FILE_ONLY TRUE
)

blender_add_lib(bf_imbuf "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")
add_library(bf::imbuf ALIAS bf_imbuf)

if(WITH_GTESTS)
  set(TEST_SRC
    tests/IMB_scaling_test.cc
    tests/IMB_transform_test.cc
  )
  blender_add_test_suite_lib(imbuf "${TEST_SRC}" "${INC}" "${INC_SYS}" "${LIB}")
  add_subdirectory(tests/performance)
endif()

=== source/blender/render/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later


set(INC
  PUBLIC .
  intern
  ../compositor
  ../compositor/cached_resources
  ../compositor/derived_resources
  ../draw/intern
  ../gpu/intern
  ../makesrna
  ../simulation
  ../../../intern/mikktspace
  ../../../intern/mantaflow/extern
)

set(INC_SYS
)

set(SRC
  intern/bake.cc
  intern/compositor.cc
  intern/engine.cc
  intern/initrender.cc
  intern/multires_bake.cc
  intern/pipeline.cc
  intern/render_result.cc
  intern/render_types.cc
  intern/texture_image.cc
  intern/texture_margin.cc
  intern/texture_pointdensity.cc
  intern/texture_procedural.cc
  intern/tile_highlight.cc
  intern/zbuf.cc

  RE_bake.h
  RE_compositor.hh
  RE_engine.h
  RE_multires_bake.h
  RE_pipeline.h
  RE_texture.h
  RE_texture_margin.h

  intern/pipeline.hh
  intern/render_result.h
  intern/render_types.h
  intern/texture_common.h
  intern/tile_highlight.h
  intern/zbuf.h
)

set(LIB
  PRIVATE bf::blenkernel
  PRIVATE bf::blenlib
  PRIVATE bf::blentranslation
  PRIVATE bf::depsgraph
  PRIVATE bf::dna
  PRIVATE bf::draw
  PRIVATE bf::extern::fmtlib
  PRIVATE bf::gpu
  PRIVATE bf::imbuf
  PRIVATE bf::imbuf::movie
  PRIVATE bf::intern::guardedalloc
  bf_compositor
  PRIVATE bf::intern::atomic
  PRIVATE bf::nodes
  PRIVATE bf::sequencer
  PRIVATE bf::windowmanager
)

if(WITH_PYTHON)
  add_definitions(-DWITH_PYTHON)
  list(APPEND INC
    ../python
  )
endif()

if(WITH_IMAGE_OPENEXR)
  list(APPEND LIB
    bf_imbuf_openexr
  )
  add_definitions(-DWITH_OPENEXR)
endif()

if(WITH_FREESTYLE)
  list(APPEND INC
    ../freestyle
  )
  list(APPEND LIB
    bf_freestyle
  )
  add_definitions(-DWITH_FREESTYLE)
endif()

if(WITH_HYDRA)
  add_subdirectory(hydra)
endif()

blender_add_lib_nolist(bf_render "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")
add_library(bf::render ALIAS bf_render)

=== source/blender/editors/asset/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  .
  ../include
  ../../makesrna
  # dna_type_offsets.h
  ${CMAKE_CURRENT_BINARY_DIR}/../../makesdna/intern
  # RNA_prototypes.hh
  ${CMAKE_BINARY_DIR}/source/blender/makesrna
)

set(INC_SYS
)

set(SRC
  intern/asset_catalog.cc
  intern/asset_filter.cc
  intern/asset_handle.cc
  intern/asset_import.cc
  intern/asset_indexer.cc
  intern/asset_library_utils.cc
  intern/asset_library_reference_enum.cc
  intern/asset_list.cc
  intern/asset_mark_clear.cc
  intern/asset_menu_utils.cc
  intern/asset_ops.cc
  intern/asset_shelf.cc
  intern/asset_shelf_asset_view.cc
  intern/asset_shelf_catalog_selector.cc
  intern/asset_shelf_popover.cc
  intern/asset_shelf_regiondata.cc
  intern/asset_shelf_settings.cc
  intern/asset_temp_id_consumer.cc
  intern/asset_type.cc
  intern/asset_ui_utils.cc

  ED_asset_catalog.hh
  ED_asset_filter.hh
  ED_asset_handle.hh
  ED_asset_import.hh
  ED_asset_indexer.hh
  ED_asset_library.hh
  ED_asset_list.hh
  ED_asset_mark_clear.hh
  ED_asset_shelf.hh
  ED_asset_temp_id_consumer.hh
  ED_asset_type.hh
  intern/asset_library_reference.hh
  intern/asset_shelf.hh
)

set(LIB
  PRIVATE bf::asset_system
  PRIVATE bf::blenkernel
  PRIVATE bf::blenlib
  PRIVATE bf::blenloader
  PRIVATE bf::blentranslation
  PRIVATE bf::dna
  PRIVATE bf::intern::clog
  PRIVATE bf::intern::guardedalloc
  PRIVATE bf::windowmanager
)

blender_add_lib(bf_editor_asset "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")

# RNA_prototypes.hh
add_dependencies(bf_editor_asset bf_rna)

=== source/blender/editors/grease_pencil/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2006-2023 Blender Authors
#
# SPDX-License-Identifier: GPL-2.0-or-later

set(INC
  ../include
  ../../makesrna
  ../../../../extern/curve_fit_nd
  ../sculpt_paint
  ../../modifiers/intern/lineart
  # RNA_prototypes.hh
  ${CMAKE_BINARY_DIR}/source/blender/makesrna
)

set(INC_SYS
)

set(SRC
  intern/grease_pencil_add.cc
  intern/grease_pencil_bake_animation.cc
  intern/grease_pencil_edit.cc
  intern/grease_pencil_frames.cc
  intern/grease_pencil_geom.cc
  intern/grease_pencil_image_render.cc
  intern/grease_pencil_join_selection.cc
  intern/grease_pencil_layers.cc
  intern/grease_pencil_lineart.cc
  intern/grease_pencil_material.cc
  intern/grease_pencil_merge.cc
  intern/grease_pencil_modes.cc
  intern/grease_pencil_ops.cc
  intern/grease_pencil_primitive.cc
  intern/grease_pencil_randomize.cc
  intern/grease_pencil_select.cc
  intern/grease_pencil_trim.cc
  intern/grease_pencil_undo.cc
  intern/grease_pencil_utils.cc
  intern/grease_pencil_vertex_paint.cc
  intern/grease_pencil_weight_paint.cc
)

set(LIB
  PRIVATE bf::blenkernel
  PRIVATE bf::animrig
  PRIVATE bf::blenlib
  PRIVATE bf::blentranslation
  PRIVATE bf::bmesh
  PRIVATE bf::depsgraph
  PRIVATE bf::dna
  PRIVATE bf::functions
  PRIVATE bf::geometry
  PRIVATE bf::gpu
  PRIVATE bf::imbuf
  PRIVATE bf::intern::guardedalloc
  PRIVATE bf::intern::clog
  PRIVATE bf::windowmanager
  extern_curve_fit_nd
  extern_fmtlib
)

blender_add_lib(bf_editor_grease_pencil "${SRC}" "${INC}" "${INC_SYS}" "${LIB}")
add_dependencies(bf_editor_curves bf_rna)

if(WITH_GTESTS)
  set(TEST_SRC
    tests/grease_pencil_merge_test.cc
  )
  set(TEST_INC
  )
  set(TEST_LIB
  )
  blender_add_test_suite_lib(editor_grease_pencil "${TEST_SRC}" "${INC};${TEST_INC}" "${INC_SYS}" "${LIB};${TEST_LIB}")
endif()

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# To build with Qt-Creator:
# 1. Launch Qt-Creator with the env (set from cmd.exe):
# set "MINGW_PREFIX=C:/msys64/mingw64"
# set "ACLOCAL_PATH=%MINGW_PREFIX%/share/aclocal:/usr/share/aclocal"
# set "PKG_CONFIG_PATH=%MINGW_PREFIX%/lib/pkgconfig"
# set "PATH=%MINGW_PREFIX%/bin;%PATH%"
# 2. Specify the following as the CMake arguments:
# -DMINGW_LIBS=%MINGW_PREFIX% -DCMAKE_BUILD_TYPE=Debug -DWITH_SYSTEM_GLEW=ON -DWITH_SYSTEM_OPENJPEG=ON -DWITH_INSTALL_PORTABLE=OFF -DWITH_OPENCOLLADA=ON -DWITH_GAMEENGINE=ON -DWITH_RAYOPTIMIZATION=ON -DWITH_JACK=OFF -DWITH_PLAYER=ON -DWITH_CODEC_FFMPEG=ON -DWITH_CODEC_SNDFILE=ON -DWITH_CYCLES=ON -DWITH_CYCLES_CUDA_BINARIES=OFF -DWITH_CYCLES_OSL=ON -DWITH_FFTW3=ON -DWITH_MOD_OCEANSIM=ON -DPYTHON_VERSION=3.7 -DPYTHON_LIBPATH=%MINGW_PREFIX%/lib -DPYTHON_LIBRARY="python3.6m" -DPYTHON_INCLUDE_DIRS=/msys64/mingw64/include/python3.6m -DWITH_PYTHON_INSTALL=OFF -DWITH_PYTHON_INSTALL_NUMPY=OFF -DPYTHON_NUMPY_PATH=%MINGW_PREFIX%/lib/python3.6/site-packages -DCYCLES_OSL=%MINGW_PREFIX% -DWITH_IMAGE_REDCODE=ON -DWITH_OPENMP=ON -DWITH_LLVM=ON -DLLVM_STATIC=ON

_realname=blender
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=4.4.3
pkgrel=3
pkgdesc="A fully integrated 3D graphics creation suite (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.blender.org"
msys2_repository_url="https://projects.blender.org/blender/blender"
msys2_references=(
  'archlinux: blender'
  'cpe: cpe:/a:blender:blender'
)
license=('spdx:GPL-2.0-or-later')
# build conflict with "${MINGW_PACKAGE_PREFIX}-glog"
depends=("${MINGW_PACKAGE_PREFIX}-alembic"
         "${MINGW_PACKAGE_PREFIX}-audaspace"
         "${MINGW_PACKAGE_PREFIX}-boost-libs"
         #"${MINGW_PACKAGE_PREFIX}-bullet-dp"
         #"${MINGW_PACKAGE_PREFIX}-draco" It builds an internal library
         "${MINGW_PACKAGE_PREFIX}-embree"
         "${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-gmp"
         "${MINGW_PACKAGE_PREFIX}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         #"${MINGW_PACKAGE_PREFIX}-gflags"
         #"${MINGW_PACKAGE_PREFIX}-glog"
         "${MINGW_PACKAGE_PREFIX}-glslang"
         "${MINGW_PACKAGE_PREFIX}-imath"
         #"${MINGW_PACKAGE_PREFIX}-jemalloc"
         "${MINGW_PACKAGE_PREFIX}-libepoxy"
         "${MINGW_PACKAGE_PREFIX}-libharu"
         "${MINGW_PACKAGE_PREFIX}-libiconv"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libsndfile"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libwebp"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread"
         "${MINGW_PACKAGE_PREFIX}-lzo2"
         #"${MINGW_PACKAGE_PREFIX}-materialx"
         #"${MINGW_PACKAGE_PREFIX}-usd"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openal"
         "${MINGW_PACKAGE_PREFIX}-opencollada"
         "${MINGW_PACKAGE_PREFIX}-opencolorio"
         "${MINGW_PACKAGE_PREFIX}-openexr"
         "${MINGW_PACKAGE_PREFIX}-openimagedenoise"
         "${MINGW_PACKAGE_PREFIX}-openimageio"
         "${MINGW_PACKAGE_PREFIX}-openjpeg2"
         "${MINGW_PACKAGE_PREFIX}-openpgl"
         "${MINGW_PACKAGE_PREFIX}-openshadinglanguage"
         "${MINGW_PACKAGE_PREFIX}-opensubdiv"
         "${MINGW_PACKAGE_PREFIX}-openvdb"
         "${MINGW_PACKAGE_PREFIX}-openxr-sdk"
         "${MINGW_PACKAGE_PREFIX}-potrace"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-python-numpy"
         "${MINGW_PACKAGE_PREFIX}-SDL2"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         "${MINGW_PACKAGE_PREFIX}-vulkan-loader"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zstd")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-vulkan-headers"
             "${MINGW_PACKAGE_PREFIX}-wintab-sdk"
             $([[ "$CARCH" == "aarch64" ]] && echo "${MINGW_PACKAGE_PREFIX}-sse2neon"))
install=blender-${MSYSTEM}.install
source=(https://download.blender.org/source/${_realname}-${pkgver}.tar.xz
        platform_win32_mingw64.cmake
        0001-mingw-buildsystem.patch
        0002-fix-mingw-w64-definitions.patch
        0003-disable-static_assert_align-on-mingw.patch
        0004-fix-rad2-conflict.patch
        0005-fix-WINTAB_PRINTF-on-mingw.patch
        0006-mingw-DEBUG-avoid-too-many-sections.patch
        0008-mingw-use-X11-like-path-layout.patch
        0009-include-missing-headers.patch
        0010-conflict-near-far-macroses.patch
        0011-no-TIME_UTC-on-msvcrt.patch
        0013-force-draco.patch
        0014-fix-find-numpy-2.patch
        0015-mingw-python-like-msvc.patch
        0016-mingw-windres.patch
        0019-fix-casts.patch
        0020-blendthumb-build.patch
        0022-find-llvm-convert-paths.patch
        0023-link-errors.patch
        0024-openvdb-shared.patch
        0025-callback-function-prototype-fix.patch
        0028-use-std-namespace.patch
        0032-fix-finding-tbb.patch
        0035-Enable-SSE2NEON-on-Windows-ARM.patch
        0039-no-WRL-on-mingw-w64.patch
        0050-fix-vulkan-import-lib-lookup.patch
        f4ad7267342bb4eb46bc6d384f4a28d10d251978.patch)
sha256sums=('99ecdef24ece14084016ee47c756eeb2fc8a09c8487a0296b45a117224dc5ca7'
            'f5765c9a5fc48b67a3eafde91dd6205e9979da0e0b582f6164b320403ef4cbf9'
            'c966881b7f4a87899e9aa9e56df434d8b8a5b138704f0605098aef28e457a853'
            '42e40277a5d86aa48eff922c90d15d2130dc80af9f2b8aed6f7269382354cb6e'
            'd6618a9004122b16bf6f27274cd6010d63abdf9fc1c3b5479d25ea5b50628f4b'
            '5a07eb6d4f9a0e7031551ede64e9359e8ebf6fc53c72579307e5016db95ff164'
            'e250fd0a992653e36b66db3f6c3708e6b6aab6513485e2813b869857307a14f2'
            'ce6f038a670be98ec1b79ef69fd716df733218c6c8b5d12dc1f13c2bb3c3e30e'
            '86aa99b789302506d1e0d74bf7dcac6ca9315aca816df3ca75fb1c3644ce15ea'
            '2d1cd06ed4d795b2341c9e8828350e29adb16fca43b30a7c644a1c7ac043c16e'
            'd4220bf1fa06b206c21b84e50febde42c2be88de68548ef208c34108ed545d8d'
            'e018b7ee07f7b8b4964fd30feb0495101d0a6b51f218652d12ae2b6369d495eb'
            '1d10ff80d5c16976c979ec507be01ac6d52f3ca1f5efd6ae3c5920e7ca3ebdc3'
            '06444eeb84d61437527d402c376024a862e60766963273868d76c604185829d1'
            '54f2569620eca6a6ad9e628a523a44bcddf96d863b749354f8bc5dd324dabeac'
            '7fb85035446d17b2b4f153af9591b0e4a7d005b42e4659a73524e1ee983c2f5e'
            '9627c4770142299b7c4717ee0fd1a4eaafc3ff51645c1cd9d07cd5aadd1a8962'
            '2e4d1f7ac01b6252b92e29c13cc00b1cd1445823f21da40d3802885512a648fe'
            '4e51f95af6999f64fac53691b2ea8a35dc59a019df9797bcea144172b3c54bd9'
            'a305329b31d2c04dc8944cd55ea6abd7333cf8c3515a04c242d567125db27caf'
            'c39bfb8c5e4f6d26601e9cb03b979265ff0bbbcb2d2758005a4d0b0ed9616c7f'
            '37927b5a4e93461343841c84bdd1c67755bd03ac14d454ad8f4a952c37049ff7'
            'bc27e13a2066fa5172bc02b580877f3d7914d4ced8842f0a8c8ed09a05844039'
            '2e0a36de42e2741122e7ab5e8895508a71d0b0db460d19013ab2424d29b52553'
            '8e8e8fc235ecccdacf775e30b7bffcf67749d78e1961710a48d40d06c7a12702'
            '4f501f1dea6a6c09d1548f45d4d0b19a757170ab9a3396ce125fa62949c4e2f9'
            '74abe05319d5f385e4f3e1206543613237ce8dfb7f6b8dd14bc73c84831f1e4e'
            'c5e205e23b56185202cdf7bd98184812ad10e8b124dbb2ceae8429d50339ecf8')
#options=(debug)

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
  cp -f ${srcdir}/platform_win32_mingw64.cmake build_files/cmake/platform/

  rm -f release/windows/icons/blender.exe.manifest

  apply_patch_with_msg \
    0001-mingw-buildsystem.patch \
    0002-fix-mingw-w64-definitions.patch \
    0003-disable-static_assert_align-on-mingw.patch \
    0004-fix-rad2-conflict.patch \
    0005-fix-WINTAB_PRINTF-on-mingw.patch \
    0008-mingw-use-X11-like-path-layout.patch \
    0009-include-missing-headers.patch \
    0010-conflict-near-far-macroses.patch \
    0011-no-TIME_UTC-on-msvcrt.patch \
    0013-force-draco.patch \
    0014-fix-find-numpy-2.patch \
    0015-mingw-python-like-msvc.patch \
    0016-mingw-windres.patch \
    0019-fix-casts.patch \
    0020-blendthumb-build.patch \
    0022-find-llvm-convert-paths.patch \
    0023-link-errors.patch \
    0024-openvdb-shared.patch \
    0025-callback-function-prototype-fix.patch \
    0028-use-std-namespace.patch \
    0032-fix-finding-tbb.patch \
    0035-Enable-SSE2NEON-on-Windows-ARM.patch \
    0039-no-WRL-on-mingw-w64.patch \
    0050-fix-vulkan-import-lib-lookup.patch \
    f4ad7267342bb4eb46bc6d384f4a28d10d251978.patch

  if check_option "debug" "y"; then
    apply_patch_with_msg \
      0006-mingw-DEBUG-avoid-too-many-sections.patch
  fi

  # Remove *.orig files
  find . -type f -name "*.orig" -exec rm -f {} \;
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM}  && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug" "-DWITH_CYCLES_DEBUG=ON" "-DWITH_GHOST_DEBUG=ON" "-DWITH_DRAW_DEBUG=ON")
  fi

  CXXFLAGS+=" -w"
  CFLAGS+=" -w"
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    CXXFLAGS+=" -Wno-c++11-narrowing"
    CFLAGS+=" -Wno-unreachable-code-generic-assoc"
  fi

  if [[ $MINGW_PACKAGE_PREFIX != *-clang-* ]]; then
    CFLAGS+=" -Wno-incompatible-pointer-types"
  fi

  if [[ $CARCH == "aarch64" ]]; then
    _extra_config+=("-DSSE2NEON_ROOT_DIR=${MINGW_PREFIX}/include/sse2neon")
  fi

  export XR_OPENXR_SDK_ROOT_DIR=${MINGW_PREFIX}
  export EMBREE_ROOT_DIR=${MINGW_PREFIX}

  _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")

  CXXFLAGS+=" -D_USE_MATH_DEFINES" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DWITH_SYSTEM_AUDASPACE=ON \
    -DWITH_SYSTEM_GFLAGS=OFF \
    -DWITH_SYSTEM_GLOG=OFF \
    -DWITH_SYSTEM_BULLET=OFF \
    -DWITH_SYSTEM_LZO=ON \
    -DWITH_SYSTEM_EIGEN3=ON \
    -DWITH_SYSTEM_FREETYPE=ON \
    -DWITH_INSTALL_PORTABLE=OFF \
    -DWITH_NANOVDB=OFF \
    -DWITH_OPENCOLORIO=ON \
    -DWITH_CYCLES=ON \
    -DWITH_CYCLES_STANDALONE=ON \
    -DWITH_CYCLES_STANDALONE_GUI=ON \
    -DWITH_CYCLES_CUDA_BINARIES=OFF \
    -DWITH_CYCLES_OSL=ON \
    -DWITH_VULKAN_BACKEND=ON \
    -DWITH_MEM_JEMALLOC=OFF \
    -DWITH_MOD_OCEANSIM=ON \
    -DPYTHON_VERSION=${_pyver} \
    -DPYTHON_LIBPATH=${MINGW_PREFIX}/lib \
    -DPYTHON_LIBRARY=${MINGW_PREFIX}/lib/libpython${_pyver}.dll.a \
    -DPYTHON_INCLUDE_DIR=${MINGW_PREFIX}/include/python${_pyver} \
    -DWITH_PYTHON_INSTALL=OFF \
    -DWITH_PYTHON_INSTALL_NUMPY=OFF \
    -DWITH_OPENMP=ON \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  cp -r bin "${pkgdir}"${MINGW_PREFIX}/
  rm "${pkgdir}"${MINGW_PREFIX}/bin/msgfmt.exe

  # Manually install draco bindings
  #_pyver=$(${MINGW_PREFIX}/bin/python -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")
  #mkdir -p "${pkgdir}${MINGW_PREFIX}/lib/python${_pyver}"/
  #mv "${pkgdir}"${MINGW_PREFIX}/share/blender/4*/python/lib/* "${pkgdir}"${MINGW_PREFIX}/lib/
  #rm -r "${pkgdir}"${MINGW_PREFIX}/share/blender/4*/python
